//===================================================================
//                                                                  =
// Author:    Martin Berriman                                       =
// Copyright: Innovatronics Ltd 2006                                =
//                                                                  =
//===================================================================

#ifndef _LCDH
#define _LCDH

#nolist

// INCLUDES =========================================================
#include "global.h"
// END INCLUDES =====================================================

// DEFINES ==========================================================
#define LCD_E		       PIN_C0
#define LCD_RW		       PIN_C1
#define LCD_RS		       PIN_C2
#define LCD_POWER	       PIN_C5

#define lcd_type 2             // 0=5x7, 1=5x10, 2=2 lines - //TODO this could be wrong
#define lcd_line_one   0x80    // 1000,0000 = 0x00 | 0x80 LCD RAM address for the second line
#define lcd_line_two   0xC0    // 1100,0000 = 0x40 | 0x80 LCD RAM address for the second line
#define lcd_line_three 0x94    // 1001,0100 = 0x14 | 0x80 LCD RAM address for the third line
#define lcd_line_four  0xD4    // 1101,0100 = 0x54 | 0x80 LCD RAM address for the fourth line

//Some useful commands that the LCD understands
#define LCD_CLEAR            0x01
#define LCD_INIT_NIBBLE      0x03
#define LCD_FOUR_BIT         0x02
#define LCD_OFF              0x08
#define LCD_ON               0x0f
#define LCD_FUNCTION_SET     0x28
#define LCD_ENTRY_MODE_SET   0x06
#define LCD_CURSOR_ON        0x0F
#define LCD_CURSOR_OFF       0x0C
#define LCD_LINE_MODE        0x0C
// END DEFINES ======================================================

// PROTOTYPES =======================================================
void lcd_printf(BYTE x, BYTE y, char * str);
BYTE lcd_read_byte();
void lcd_send_nibble(BYTE n);
void lcd_send_byte(BYTE address, BYTE n);
void lcd_init();
void lcd_gotoxy(BYTE x, BYTE y);
void lcd_putc(char c);
char lcd_getc(BYTE x, BYTE y);
void lcd_clear_line(BYTE line);
void lcd_screen_on(void);
void lcd_screen_off(void);
void set_tris_read();
void set_tris_write();
// END PROTOTYPES ===================================================

#list

// =============================================================
#endif
